/*------------------------------------------------------------------------
    File        : basic_auth.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Mon Jun 08 09:58:14 EDT 2015
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

block-level on error undo, throw.

using OpenEdge.Net.HTTP.AuthenticationRequestEventArgs.
using OpenEdge.Net.HTTP.ClientBuilder.
using OpenEdge.Net.HTTP.Credentials.
using OpenEdge.Net.HTTP.IHttpClient.
using OpenEdge.Net.HTTP.IHttpRequest.
using OpenEdge.Net.HTTP.IHttpResponse.
using OpenEdge.Net.HTTP.RequestBuilder.
using Progress.Json.ObjectModel.JsonObject.
using Progress.Lang.Object.

block-level on error undo, throw.


    define variable moHttpClient as IHttpClient no-undo.
          
    moHttpClient  = ClientBuilder:Build():Client.
    
    run BasicCallback.
    

    procedure BasicInline:
        define variable oReq as IHttpRequest no-undo.
        define variable oResp as IHttpResponse no-undo.
        define variable oEntity as Object no-undo.
        define variable oJsonEntity as JsonObject no-undo.
        define variable oCreds as Credentials no-undo.
        
        oCreds = new Credentials('domain-name', 'user-name', 'user-pass').
        
        oReq = RequestBuilder:Get('http://httpbin.org/basic-auth/user-name/user-pass')
                :UsingBasicAuthentication(oCreds)
                :Request.
        
        oResp = moHttpClient:execute(oreq).
        
        oJsonEntity = cast(oResp:Entity, JsonObject).
                
        message 
        oResp:StatusCode skip
        'authenticated user=' oJsonEntity:GetCharacter('user')
        view-as alert-box.
        
    end procedure.    
    
    procedure BasicCallback:
        define variable oReq as IHttpRequest no-undo.
        define variable oResp as IHttpResponse no-undo.
        define variable oEntity as Object no-undo.
        define variable oJsonEntity as JsonObject no-undo.
        define variable oCreds as Credentials no-undo.
        
        oCreds = new Credentials('domain-name', 'username', 'userpass').
        
        oReq = RequestBuilder:Get('http://httpbin.org/basic-auth/username/userpass')
/*                :AuthCallback(this-procedure)*/
                :Request.
        
        oResp = moHttpClient:execute(oreq).
        oJsonEntity = cast(oResp:Entity, JsonObject).
                
        message 
        oResp:StatusCode skip
        'authenticated user=' oJsonEntity:GetCharacter('user')
        view-as alert-box.
    end procedure.    
    
    procedure AuthFilter_HttpCredentialRequestHandler:
    define input parameter poSender as Object.
    define input parameter poEventArgs as AuthenticationRequestEventArgs.
    
    define variable cName as character no-undo.
    define variable cPass as character no-undo.
    
    update cName label 'User name:' format 'x(20)'
            cPass label 'Password:' format 'x(20)' password-field
            
            with side-labels 1 column.
        
    poEventArgs:Credentials = new Credentials('my-domain', cName, cPass). 
    
end procedure.
                        
    