
/*------------------------------------------------------------------------
    File        : post_xml_pdf.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Mon Jun 08 09:49:41 EDT 2015
    Notes       :
  ----------------------------------------------------------------------*/
block-level on error undo, throw.

using OpenEdge.Core.Assert.
using OpenEdge.Core.ByteBucket.
using OpenEdge.Core.Memptr.
using OpenEdge.Core.WidgetHandle.
using OpenEdge.Net.HTTP.ClientBuilder.
using OpenEdge.Net.HTTP.IHttpClient.
using OpenEdge.Net.HTTP.IHttpRequest.
using OpenEdge.Net.HTTP.IHttpResponse.
using OpenEdge.Net.HTTP.RequestBuilder.
using Progress.Json.ObjectModel.JsonObject.
using Progress.Lang.Object.
using OpenEdge.Net.HTTP.StatusCodeEnum.

    define variable moHttpClient as IHttpClient no-undo.
          
    moHttpClient  = ClientBuilder:Build():Client.
    
    run PostXML.
    run PdfData.

    procedure PostXML:
        define variable oReq as IHttpRequest no-undo.
        define variable oResp as IHttpResponse no-undo.
        define variable oEntity as Object no-undo.
        define variable oJsonEntity as JsonObject no-undo.
        define variable lcInputSoapRequest as longchar no-undo.
        define variable lcOutputSoapRequest as longchar no-undo.
        define variable lEqual as logical no-undo.
        define variable hXmlDoc as handle no-undo.
        
        lcInputSoapRequest = '<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><SOAP-ENV:Body xmlns:s0="http://www.w3.org/2001/XMLSchema"><ns0:Roundtrip xmlns:ns0="urn:progress-webservices:WSTest"><ns0:ipcText xsi:type="s0:string">Test Message</ns0:ipcText><ns1:ipiNum xsi:type="s0:int" xmlns:ns1="urn:progress-webservices:WSTest">9999</ns1:ipiNum></ns0:Roundtrip></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
        create x-document hXmlDoc.
        hXmlDoc:load('longchar', lcInputSoapRequest, false).
        
        oReq = RequestBuilder:Post('http://httpbin.org/post', 
                                   new WidgetHandle(hXmlDoc))
                   :AcceptJson()
                   :Request.

        message 
        oReq:ContentType skip
        oReq:ContentLength skip
        oReq:AcceptContentType[1]
        view-as alert-box.

        oResp = moHttpClient:Execute(oReq).
        
        oEntity = oResp:Entity.
        
        assign oJsonEntity = cast(oEntity, JsonObject).
        oJsonEntity:WriteFile(session:temp-dir + 'postxml.json':u, true).
    end procedure.     
    
    procedure PdfData:
        define variable oRequest as IHttpRequest no-undo.
        define variable oResponse as IHttpResponse no-undo.
        define variable oInputEntity as class Memptr no-undo.
        define variable oJsonEntity as JsonObject no-undo.
        define variable mDocument as memptr no-undo.
        define variable oMessageBody as ByteBucket no-undo.
        define variable oEntity as Object no-undo.
        
        copy-lob from file session:temp-directory + 'document.pdf':u
                 to mDocument.
                 
        oInputEntity = new Memptr(get-pointer-value(mDocument),
                                  get-size(mDocument)). 
        
        oRequest = RequestBuilder:Post('http://httpbin.org/post', oInputEntity)
                        :ContentType('application/pdf':u)
                        :Request.

        oResponse = moHttpClient:Execute(oRequest).
        
        assign oJsonEntity = cast(oResponse:Entity, JsonObject).
        oJsonEntity:WriteFile(session:temp-dir + 'pdfdata.json':u, true).
        
        finally:
            set-size(mDocument) = 0.
        end finally.        
    end procedure.
          
